/* apdopreferences
  creates discounts and utilities tables from preferences table
*/

void apdopreferences()
{
   int i,j;

  // check for no discounts or utilities tables -- exit if either is present
     nerrors = 0;
     if (discounts != NULL) nerrors = nerrors+1;
     if (utilities != NULL) nerrors = nerrors+1;
     if (nerrors>0) aperrorhalt("Neither discounts nor utilities table can be present when preference table is used");

  // make discounts matrix for time preferences
      discounts = new double[ninvestors*nstates];  
      discountsrows = ninvestors;
      discountscolumns = nstates;
      discountssize = ninvestors*nstates;
      for (i=0;i<ninvestors;i++)
        {
        #ifdef MEMCHECK
           if ((i*nstates+0)>discountssize) aperrorhalt("Memory error: apdopreferences 01");
        #endif      
        discounts[i*nstates+0] = 1;
        for (j=1;j<nstates;j++)
          {
          #ifdef MEMCHECK
             if ((i*nstates+j)>discountssize) aperrorhalt("Memory error: apdopreferences 02");
          #endif      
          discounts[i*nstates+j] = preferences[i*2+0];
          }
        }  
    
  // make utilities matrix for one CRRA function
      utilities = new double[ninvestors*2];  
      utilitiesrows =  ninvestors;
      utilitiescolumns = 2;
      utilitiessize = ninvestors*2;
      for (i=0;i<ninvestors;i++)
        {
          #ifdef MEMCHECK
             if ((i*2+0)>utilitiessize) aperrorhalt("Memory error: apdopreferences 03");
          #endif      
          utilities[i*2+0] = 2;
          #ifdef MEMCHECK
             if ((i*2+1)>utilitiessize) aperrorhalt("Memory error: apdopreferences 04");
          #endif      
          utilities[i*2+1] = preferences[i*2+1];
        }    
      utilitiesnames = new char[100];
      strcpy(utilitiesnames,"|Type|Parameter|");
} 