/* apdotrials
  does trials to make new predictions table
*/

void apdotrials()
{
   int i,j,s,t,ntrials,c,trialstate;
   double sum,x,prbx,wt;
   double *oldtable=NULL;
     int oldtablerows,oldtablecolumns,oldtablesize;
   double *cumprb=NULL;
     int cumprbcolumns,cumprbsize;
   double *freq=NULL;
     int freqcolumns,freqsize;

 //  printf("dotrials\n");
   
// make vectors for cumulative probabilities and frequency distribution from trials
   cumprb = new double[nstates+1];
     cumprbcolumns = nstates+1;
     cumprbsize = nstates+1;
   freq = new double[nstates+1];
     freqcolumns = nstates+1;
     freqsize = freqcolumns;
   
// check number of rows in information table
    if (informationrows != ninvestors) aperrorhalt("Number of rows in information table does not equal number of investors");
    
// if table has two rows, expand to four
    if (informationcolumns == 2)
    {
        oldtable = information;
        oldtablerows = informationrows;
        oldtablecolumns = informationcolumns;
        oldtablesize = informationsize;
        information = new double[ninvestors*4];  
        informationrows = ninvestors;
        informationcolumns = 4;
        informationsize = ninvestors*4;
        for(i=0;i<ninvestors;i++)
        {
           #ifdef MEMCHECK
                if ((informationcolumns*i+3)>informationsize) aperrorhalt("Memory error: apdotrials 01");
           #endif      
           information[informationcolumns*i+0] = oldtable[oldtablecolumns*i+0]; 
           information[informationcolumns*i+1] = 2;
           information[informationcolumns*i+2] = oldtable[oldtablecolumns*i+1];
           information[informationcolumns*i+3] = 1;
        }
    }
    
    if (informationcolumns != 4) aperrorhalt("Number of columns in predictions table does not equal 2 or 4");
    
 // check for weights on prior predictions greater than zero and less than or equal to 1
     nerrors = 0;
     for (i=0;i<ninvestors;i++)
          if ((information[informationcolumns*i+0]<= 0.0) || (information[informationcolumns*i+0]>1)) nerrors = nerrors+1;
     if (nerrors>0) aperrorhalt("Information table: the weight on prior predictions must greater than 0 and less than 1");
   
 // check for number of samples greater than or equal to 1
     nerrors = 0;
     for (i=0;i<ninvestors;i++)
        if (information[informationcolumns*i+2]< 1)  nerrors = nerrors+1;
     if (nerrors>0) aperrorhalt("Information table: the number of samples must be greater than or equal to 1");

     
  // check for 1 or 2 in field 2 
     nerrors = 0;
     for (i=0;i<ninvestors;i++)
         if ((information[informationcolumns*i+1]!=1)&&(information[informationcolumns*i+1]!=2))  nerrors = nerrors+1;
     if (nerrors>0) aperrorhalt("Information table: the code for the probabilities to be used for the prior must be 1 (probabilities) or 2 (predictions)");
    
   // check for 1 or 2 in field 4 
     nerrors = 0;
     for (i=0;i<ninvestors;i++)
         if ((information[informationcolumns*i+3]!=1)&&(information[informationcolumns*i+3]!=2))  nerrors = nerrors+1;
     if (nerrors>0) aperrorhalt("Information table: the code for the probabilities to be used for the samples must be 1 (probabilities) or 2 (predictions)");
     
    
  // seed random number generator
       if (RANDSEED==0) srand( (int) time(NULL));
       if (RANDSEED!=0) srand(RANDSEED);
         
    // make new predictions table
      for (i=0;i<ninvestors;i++)
     {
        // make cumulative distribution of selected probabilities for future states
           c = information[informationcolumns*i+3];
           cumprb[0] = 0;
           for (s=1;s<nstates;s++)
           { 
              if (c==1) prbx = probabilities[s];
              if (c==2) prbx = predictions[predictionscolumns*i+s];
              #ifdef MEMCHECK
                  if (s>cumprbsize) aperrorhalt("Memory error: apdotrials 02");
              #endif      
              cumprb[s] = cumprb[s-1]+prbx;
           }

    // get frequency distribution of trials 
           freq[0] = 0;
           for (s=0;s<nstates;s++) freq[s]=0;
           ntrials= information[informationcolumns*i+2];
           for (t=0;t<ntrials;t++)
           {
             x = (double) rand()/RAND_MAX;  // random number between 0 and 1
             trialstate = nstates;
             for (s=1;s<nstates;s++)
             {
                if ((x>=cumprb[s-1])&&(x<cumprb[s])) trialstate = s;
             }
             #ifdef MEMCHECK
                if (trialstate>freqsize) aperrorhalt("Memory error: apdotrials 03");
             #endif      
             freq[trialstate] = freq[trialstate]+1;
           }
           
    // convert to probability distribution       
           sum=0;
           for (s=0;s<nstates;s++) sum = sum + freq[s];
           for (s=0;s<nstates;s++) 
           {  
              #ifdef MEMCHECK
                 if (s>freqsize) aperrorhalt("Memory error: apdotrials 04");
              #endif      
              freq[s]=freq[s]/sum;           
           }   
           
    // mix with prior           
       wt = information[informationcolumns*i+0];
       c = information[informationcolumns*i+1];          
       predictions[predictionscolumns*i+0] = 1;
       for (s=1;s<nstates;s++)
       {
         #ifdef MEMCHECK
             if ((predictionscolumns*i+s)>predictionssize) aperrorhalt("Memory error: apdotrials 05");
         #endif      
         if (c==1) predictions[predictionscolumns*i+s] = (wt*probabilities[s])+ (1-wt)*freq[s];
         if (c==2) predictions[predictionscolumns*i+s] = (wt*predictions[predictionscolumns*i+s]) + (1-wt)*freq[s];
       }

    }  
 } 
 
 