int apgetbm(FILE *fid)
{
  
/* apgetbm
  reads a bordered matrix 
  returns global variables:
    bmname:      string  name of matrix                   (new)
    bmnrows:     int     number of rows in array
    bmncols:     int     number of columns in array
    bmnsize:     int     length of bmmat
    bmcolnames:  string  | separated list of column names (new)
    bmrownames:  string  | separated list of row names    (new) 
    bmmat        double  matrix as new row-wise array     (new)  

 source file is pointed to by fid
    information in bordered matrix format 
    
 returns feof indicator while reading matrix   

 limitations
   matrix name and each row or column name must be less than 110 characters
   all matrix entries must be numeric

 gets bordered matrix from file fid and puts results in global variables
   *bmname, *bmcolnames, *bmrownames, bmnrows, bmncols and *bmmat
   variables are allocated on the heap and the address returned to pointers
   returns 1 if no more matrices are left on the file, 0 otherwise
*/

   char stg[200];
   FILE *fido;
   char *loc;
   char letter,c;
   int row,col,lgth,cc;
   double mval;
   
 // read matrix name
      fgets(stg,200,fid); stg[strlen(stg)-1] = '\0';
      bmname = new char[strlen(stg)+1];  
      strcpy(bmname,stg);
  // skip separator
      fgets(stg,200,fid);
  // read total number of rows and columns
      fscanf(fid,"%d ",&bmnrows);
      fscanf(fid,"%d ",&bmncols);
  // subtract one to get size of actual matrix
      bmnrows = bmnrows-1;
      bmncols = bmncols-1;
  // skip separator
      fgets(stg,200,fid);
 // get column names
      fido=fopen("c:/apsim/apsimtemp.txt","w");
      fputs("|",fido);
      lgth=1;
      for (col=0;col<bmncols;col++)
      {
         fgets(stg,200,fid); stg[strlen(stg)-1] = '\0';
         fputs(stg,fido);
         fputs("|",fido);
         lgth = lgth + strlen(stg) +1;
      }
         fclose(fido);
         bmcolnames = new char[lgth+1];  
         fido=fopen("c:/apsim/apsimtemp.txt","r");
         fgets(bmcolnames,100000,fido);
         bmcolnames[strlen(bmcolnames)] = '\0';
         fclose(fido);
  // skip separator
      fgets(stg,200,fid);
  // get row names
      fido=fopen("c:/apsim/apsimtemp.txt","w");
      fputs("|",fido);
      lgth=1;
      for (row=0;row<bmnrows;row++)
      {
         fgets(stg,200,fid); stg[strlen(stg)-1] = '\0';
         fputs(stg,fido);
         fputs("|",fido);
         lgth = lgth + strlen(stg) +1;
      }
      fclose(fido);
      bmrownames = new char[lgth+1];  
      fido=fopen("c:/apsim/apsimtemp.txt","r");
      fgets(bmrownames,100000,fido);
      fclose(fido);
  // skip separator
      fgets(stg,200,fid);
  // create array for matrix
      bmnsize = bmnrows*bmncols;
      bmmat = new double[bmnsize];
  // get matrix entries
     for (row=0;row<bmnrows;row++)
     {
        for (col=0;col<bmncols;col++)
        {
             fgets(stg,200,fid);
             // replace any comma with a decimal point (to handle commas used as decimal separators)
                for (cc=0;cc<strlen(stg);cc++)
                   if (stg[cc] ==',') stg[cc] = '.';
             sscanf(stg,"%lf",&mval);
             #ifdef MEMCHECK
               if ((row*bmncols+col)>bmnsize) aperrorhalt("Memory error: apgetbm 01");
             #endif   
             bmmat[row*bmncols+col] = mval;
        }
     }
     
   // read separator and newline
      fgets(stg,200,fid);
      
   // return feof(fid) after trying to read matrix -- this is >0 if eof encountered
      return (feof(fid));
 }

