/* apgetcase
  gets bordered matrices from apsimcase.txt
  stores those with designated names in global variables
*/

void apgetcase()
{
 FILE *fid;
 char stg[110];
 int feofid;
 int lgth;
 int i,j;
 double BLANK = -9.999E-100;
 
 // open input (case) file
     fid=fopen("c:/apsim/apsimcase.txt","r");
 
 // read case name
      fgets(stg,100,fid);
      
 // get bordered matrices
   while (feof(fid)==0)
   {
       // get next bordered matrix
          feofid = apgetbm(fid);
          
      // skip if eof encountered when reading matrix
          if (feofid>0) continue;
          
      // change any upper case to lower case in matrix name
          lgth = strlen(bmname);
          for (int i=0;i<lgth;i++) bmname[i] = tolower(bmname[i]);
        
      // process based on name 
   
        if (strncmp(bmname,"securities:",1000)==0) 
          {
            securities = bmmat;
               securitiesrows = bmnrows;
               securitiescolumns = bmncols;
               securitiessize = bmnsize;
            nstates = bmnrows;
            nsecurities = bmncols;
            statenames = bmrownames;
            securitynames = bmcolnames;  
          }
          
       if (strncmp(bmname,"portfolios:",1000)==0) 
          {
            portfolios = bmmat;
               portfoliosrows = bmnrows;
               portfolioscolumns = bmncols;
               portfoliossize = bmnsize;
            ninvestors = bmnrows;
            investornames = bmrownames;
          }
          
       if (strncmp(bmname,"probabilities:",1000)==0) 
          {
            probabilities = bmmat;
               probabilitiesrows = bmnrows;
               probabilitiescolumns = bmncols;
               probabilitiessize = bmnsize;
          }

       if (strncmp(bmname,"preferences:",1000)==0) 
          {
            preferences = bmmat;
               preferencesrows = bmnrows;
               preferencescolumns = bmncols;
               preferencessize = bmnsize;
          }

       if (strncmp(bmname,"discounts:",1000)==0) 
          {
            discounts = bmmat;
               discountsrows = bmnrows;
               discountscolumns = bmncols;
               discountssize = bmnsize;
          }          

      if (strncmp(bmname,"salaries:",1000)==0) 
          {
            salaries = bmmat;
               salariesrows = bmnrows;
               salariescolumns = bmncols;
               salariessize = bmnsize;
          }          
          
      if (strncmp(bmname,"collateral:",1000)==0) 
          {
            collateral = bmmat;
               collateralrows = bmnrows;
               collateralcolumns = bmncols;
               collateralsize = bmnsize;
          }          
          
       if (strncmp(bmname,"utilities:",1000)==0) 
          {
            utilities = bmmat;
               utilitiesrows = bmnrows;
               utilitiescolumns = bmncols;
               utilitiessize = bmnsize;
               utilitiesnames = bmcolnames;
          }          
          
         if (strncmp(bmname,"predictions:",1000)==0) 
          {
            predictions = bmmat;
               predictionsrows = bmnrows;
               predictionscolumns = bmncols;
               predictionssize = bmnsize;
          }     

         if (strncmp(bmname,"information:",1000)==0) 
          {
            information = bmmat;
               informationrows = bmnrows;
               informationcolumns = bmncols;
               informationsize = bmnsize;
          }     
          
        if (strncmp(bmname,"controls:",1000)==0) 
          {
            controls = bmmat;
               controlsrows = bmnrows;
               controlscolumns = bmncols;
               controlssize = bmnsize;
               controlsnames = bmrownames;
          }              
      // for all but utilities, reject if any blanks (-9.999E-100)
         if (strncmp(bmname,"utilities:",1000)!=0)
         {
           nerrors = 0;
           for (i=0;i<bmnrows;i++)
           {
           for (j=0;j<bmncols;j++)
               {
                 #ifdef MEMCHECK
                     if ((bmncols*i+j)>bmnsize) aperrorhalt("Memory error: apgetcase 01");
                 #endif   
                 if (bmmat[bmncols*i+j] == BLANK) nerrors= nerrors+1;
               }   
           }   
         }  
           
         if (nerrors>0)
         {
            fprintf(fiderr,"ERROR:\n");
            fprintf(fiderr,"  %s Table contains blanks or non-numeric characters\n",bmname);
            fprintf(fiderr,"  Please correct, then process again\n"); fclose (fiderr);
            exit(0);   
         };
         
   } // end while
   
       
 // close case file
      fclose(fid);
      
} 