/* apgetportcons.cpp
   makes and gets portfolio consumption matrix from product of portfolio and securities matrices
   makes claims matrix for holdings of state claims and sets all entries to zero
   makes marketclaims vector
   recomputes consumptions matrix to include claims
*/

void apgetportcons()
{
  int inv,state,sec,invrow;
  double mval;
      
  // make portfolio consumption matrix from portfolio holdings and securities payoffs (C = P*S')
      portconsumptions = new double[ninvestors*nstates];
      portconsumptionssize = ninvestors*nstates;
      for (inv=0;inv<ninvestors;inv++)
        { 
          invrow = nstates*inv;
          for(state=0;state<nstates;state++) 
          {
             mval = 0;
             for (sec=0;sec<nsecurities;sec++) 
             {
                 mval = mval + portfolios[nsecurities*inv+sec]*securities[nsecurities*state+sec];  
             }   
             #ifdef MEMCHECK
               if ((invrow+state)>portconsumptionssize) aperrorhalt("Memory error: apgetportcons 01");
             #endif   
             portconsumptions[invrow+state] = mval;
          }    
        }     
       
   // make market claims vector         
        marketclaims = new double[nstates];
          marketclaimssize = nstates;
   // recompute consumptions matrix       
       apsgetcons();
   
}