/* apgetpower.cpp
   gets power for power SML
   regresses log(PPC) on log(market consumption) for future states
   slope coefficient is smlpower
   r2power is r2
*/

 
void apgetpower()
{
  double logm,logc,cov,sumx,sumy,sumxy,sumx2,sumy2;
  double covxy,meanx,meany,varx,vary,a,df;
  int i,n;
  char c;
  
  n = 0;
  sumx = 0;
  sumy = 0;
  sumxy = 0;
  sumx2 = 0;
  sumy2 = 0;
  for (i=1;i<nstates;i++)
  {
    n =  n+1;
    logm = log(respstates[i]/probabilities[i]);
    logc = log((marketconsumption[i]/marketconsumption[0]));
    sumx = sumx + logc;
    sumy = sumy + logm;
    sumxy = sumxy + (logm*logc);
    sumx2 = sumx2 + (logc*logc);
    sumy2 = sumy2 + (logm*logm);
  }
  meanx = sumx/n;
  meany = sumy/n;
  covxy = (sumxy/n) - (meanx*meany);
  varx = (sumx2/n) - (meanx*meanx);
  vary = (sumy2/n) - (meany*meany);
  smlpower = covxy/varx;
  a = meany - smlpower*meanx;
  df = exp(a);
  
  r2power = covxy/(sqrt(varx)*sqrt(vary));
  r2power = r2power*r2power;

 // put in matrix
    #ifdef MEMCHECK
         if (1>powerparamssize) aperrorhalt("Memory error: apgetpower 01");
    #endif   
    powerparams[0] = -smlpower;
    powerparams[1] = df;
    powerparams[2] = r2power;
   }