/* apmakecontrols
  makes or completes controls table and checks format
*/

void apmakecontrols()
{
   int i,j,oldtablerows,oldexists;
   double *oldtable=NULL;
   double v;
   
  // if table exists, save as oldtable
     oldexists = 0;
     if (controls != NULL) 
       {
        oldtable = controls;
        oldtablerows = controlsrows;
        oldexists = 1;
       } 

  // make a default controls table
       controlsrows = 5;
       controlscolumns = 1;
       controlssize = controlsrows*controlscolumns;
       controlsnames = new char[100];
       strcpy(controlsnames,"|Pct Price Spread|Complete Market|Random # Seed|Min. Consumption|Number of Prices|");
       controls = new double[controlsrows*controlscolumns];  
       controls[0] = 0.001;
       controls[1] = 0;
       controls[2] = 0;
       controls[3] = 1;
       controls[4] = 1;
 
   // if old table exists, post values to new table
      if (oldexists==1)
        {
          for(i=0;i<oldtablerows;i++) 
          {
              #ifdef MEMCHECK
                 if (i>controlssize) aperrorhalt("Memory error: apmakecontrols 01");
              #endif      
              controls[i] = oldtable[i];
          }    
        }   
      
   // check controls
   
      // size must be 4*1
         if ((controlsrows != 5)||(controlscolumns!=1)) aperrorhalt("Controls table must have 5 rows and 1 column");

     // maximum price spread -- must be positive and less than 100    
         if (controls[0]<=0) aperrorhalt("Controls table row 1: Maximum percentage price spread must be positive");
         if (controls[0]>=100) aperrorhalt("Controls table row 1: Maximum percentage price spread must be less than 100");

     // complete market -- 0 or 1
         i= controls[1];
         if ((i!=0) && (i!=1)) aperrorhalt("Controls table row 2: Complete market parameter must be 0 or 1");

     // random number seed -- must be positive
         if (controls[2]<0) aperrorhalt("Controls table row 3: Random number seed must be zero or positive");
         
     // minimum consumption -- must be greater than or equal to 1
         if (controls[3]< 1) aperrorhalt("Controls table row 4: Minimum consumption must be greater than or equal to 1");
         
     // number of prices -- must be positive 
         if (controls[4]< 1) aperrorhalt("Controls table row 5: Number of prices in price discovery must be 1 or greater");
  
     // set control variables
        MAXPRICESPREAD = controls[0]/100;
        COMPMKT = controls[1];
        RANDSEED = controls[2];
        MINCONSUMPTION = controls[3];
        NUMPRICES = controls[4];
        
  } 
 
 