/* apmakepreds
  makes predictions table if needed, then checks for proper form
*/

void apmakepreds()
{
   int i,j;
   double sum;
   
  // make predictions matrix for agreement if needed
     if (predictions == NULL)
      {
         predictions = new double[ninvestors*nstates];  
         predictionsrows = ninvestors;
         predictionscolumns = nstates;
         predictionssize = ninvestors*nstates;
         for (i=0;i<ninvestors;i++)
            for (j=0;j<nstates;j++)
            {
              #ifdef MEMCHECK
                  if ((i*nstates+j)>predictionssize) aperrorhalt("Memory error: apmakepreds 01");
               #endif      
               predictions[i*nstates+j] = probabilities[j];
            }   
      }         

   // check number of rows and columns in predictions table
    if (predictionsrows != ninvestors) aperrorhalt("Number of rows in predictions table does not equal number of investors");
    
    if (predictionscolumns != nstates) aperrorhalt("Number of columns in predictions table does not equal number of states");

 // check for all entries greater than zero and less than or equal to 1
     nerrors = 0;
     for (i=0;i<ninvestors;i++)
       for (j=0;j<nstates;j++) 
       { 
          if ((predictions[nstates*i+j] <= 0.0) || (predictions[nstates*i+j] > 1.0) ) nerrors = nerrors+1;
       }
     if (nerrors>0) aperrorhalt("Predictions table: each probability must be greater than 0 and less than or equal to 1");

  // check for 1s in first column of predictions table
      nerrors = 0;
      for (i=0;i<ninvestors;i++) 
      {
         if (predictions[i*nstates+0] != 1) nerrors = nerrors +1;
      }
       if (nerrors>0) aperrorhalt("Predictions table: all entries in the first column must equal 1");

 // check for sum of entries equal from column 2 to nstates equals 1
     for (i=0;i<ninvestors;i++)
     {
        sum = 0;
        for (j=1;j<nstates;j++) sum = sum + predictions[nstates*i+j];
        if ( (sum > 1.00001) || (sum < 0.99999) ) aperrorhalt("Predictions table: in each row the sum of second through last entries must equal 1");
     }

 // make entries for future states sum exactly to 1
    for (i=0;i<ninvestors;i++)
    {
       sum = 0;
       for (j=1;j<nstates;j++) sum = sum + predictions[nstates*i+j];
       for (j=1;j<nstates;j++)
       {
          #ifdef MEMCHECK
              if ((nstates*i+j)>predictionssize) aperrorhalt("Memory error: apmakepreds 02");
          #endif      
          predictions[nstates*i+j] = predictions[nstates*i+j]/sum;
       }   
    };   
    

 } 
 
 