/* apmakesc
  checks salaries and collateral tables and makes and expands if necessary
*/

void apmakesc()
{
   int i,j;
   double *oldtable=NULL;
 
 // check for presence of salaries table -- if missing, make it 
    if (salaries == NULL) 
    {
      salaries = new double[ninvestors*nstates];  
      salariesrows = ninvestors;
      salariescolumns = nstates;
      salariessize = ninvestors*nstates;
      for (i=0;i<ninvestors;i++) 
      {
          for (j=0;j<nstates;j++)
          {
             #ifdef MEMCHECK
                if ((i*nstates+j)>salariessize) aperrorhalt("Memory error: apmakesc 01");
             #endif      
             salaries[i*nstates+j] = 0;
          }
       }   
    }
    
 // check number of rows in salaries table
    if (salariesrows != ninvestors) aperrorhalt("Number of rows in salaries table does not equal number of investors");

 // if salaries table has only one column, expand it
     if (salariescolumns == 1)
     {
        oldtable = salaries;
        salaries = new double[ninvestors*nstates];  
        salariescolumns = nstates;
        salariessize = ninvestors*nstates;
        for (i=0;i<ninvestors;i++)
        {
          #ifdef MEMCHECK
             if ((i*nstates+0)>salariessize) aperrorhalt("Memory error: apmakesc 02");
          #endif      
          salaries[i*nstates+0] = 0;
          for (j=1;j<nstates;j++)
          {
            #ifdef MEMCHECK
               if ((i*nstates+j)>salariessize) aperrorhalt("Memory error: apmakesc 03");
            #endif      
            salaries[i*nstates+j] = oldtable[i];
          }
        }
     }
 
    // check for 0s in first column of salaries table
      nerrors = 0;
      for (i=0;i<ninvestors;i++) 
      {
         if (salaries[i*nstates+0] != 0) nerrors = nerrors +1;
      }
       if (nerrors>0) aperrorhalt("Salaries table: all entries in the first column must equal 0");
  
    // check for positive values in remainder of salaries table
      nerrors = 0;
      for (i=0;i<ninvestors;i++) 
      {
          for (j=1;j<nstates;j++)
          {
             if (salaries[i*nstates+j] < 0) nerrors = nerrors +1;
          }
       }   
       if (nerrors>0) aperrorhalt("Salaries table: no negative entries allowed");
       
// check for presence of collateral table -- if missing, make it
    if (collateral == NULL) 
    {
      collateral = new double[ninvestors*nstates];  
      collateralrows = ninvestors;
      collateralcolumns = nstates;
      collateralsize = ninvestors*nstates;
      for (i=0;i<ninvestors;i++) 
      {
          for (j=0;j<nstates;j++)
          {
            #ifdef MEMCHECK
               if ((i*nstates+j)>collateralsize) aperrorhalt("Memory error: apmakesc 04");
            #endif      
            collateral[i*nstates+j] = 0;
          }
       }   
    }
    
 // check number of rows in collateral table
    if (collateralrows != ninvestors) aperrorhalt("Number of rows in collateral table does not equal number of investors");

 // if collateral table has only one column, expand it
     if (collateralcolumns == 1)
     {
        oldtable = collateral;
        collateral = new double[ninvestors*nstates];  
        collateralcolumns = nstates;
        collateralsize = ninvestors*nstates;
        for (i=0;i<ninvestors;i++)
        {
          #ifdef MEMCHECK
             if ((i*nstates+0)>collateralsize) aperrorhalt("Memory error: apmakesc 05");
          #endif      
          collateral[i*nstates+0] = 0;
          for (j=1;j<nstates;j++)
          {
            #ifdef MEMCHECK
               if ((i*nstates+j)>collateralsize) aperrorhalt("Memory error: apmakesc 06");
            #endif      
            collateral[i*nstates+j] = oldtable[i];
          }
        }
     }
 
    // check for 0s in first column of collateral table
      nerrors = 0;
      for (i=0;i<ninvestors;i++) 
      {
         if (collateral[i*nstates+0] != 0) nerrors = nerrors +1;
      }
       if (nerrors>0) aperrorhalt("Collateral table: all entries in the first column must equal 0");
  
    // check for positive values in remainder of collateral table
      nerrors = 0;
      for (i=0;i<ninvestors;i++) 
      {
          for (j=1;j<nstates;j++)
          {
             if (collateral[i*nstates+j] < 0) nerrors = nerrors +1;
          }
       }   
       if (nerrors>0) aperrorhalt("Collateral table: no negative entries allowed");
              
  } 
 
 