/* apmakestd.cpp
   make standard matrices
*/

void apmakestd()
{
 
   int i,j,k,num,cnt,lgth,inv,invrow,state,sec;
   double mval,invmin;

 // make discpred matrix with products of discounts and predictions
      discpred = new double[ninvestors*nstates];  
      discpredsize = ninvestors*nstates;
      for (i=0;i<ninvestors;i++)
        { 
          for(j=0;j<nstates;j++) 
          {
           #ifdef MEMCHECK
                if ((i*nstates+j)>discpredsize) aperrorhalt("Memory error: apmakestd 01");
           #endif      
          discpred[i*nstates+j] = discounts[i*nstates+j]*predictions[i*nstates+j];
          }    
        }     
      discpredsize = ninvestors*nstates;
     
  // make claims matrix and set to zero
      claims = new double[ninvestors*nstates];  
      claimssize = ninvestors*nstates;
         for (inv=0;inv<ninvestors;inv++)
         {
            invrow = nstates*inv;
            for(state=0;state<nstates;state++) 
              {
                 #ifdef MEMCHECK
                   if ((invrow+state)>claimssize) aperrorhalt("Memory error: apmakestd 02");
                 #endif      
                 claims[invrow+state] = 0;
              }   
         }  
         claimssize = ninvestors*nstates;
        
  // make consumptions matrix and initialize 
      consumptions = new double[ninvestors*nstates];
      consumptionssize = ninvestors*nstates;
      apgetcons();
       
  // check consumption matrix for violations of minimum consumption
      nerrors = 0;
      for (i=0;i<ninvestors;i++)
      {
         for(j=0;j<nstates;j++) 
            if (consumptions[nstates*i+j] <= MINCONSUMPTION) nerrors = nerrors+1;
      }   
      if (nerrors>0) aperrorhalt("Consumption for every investor must exceed the minimum consumption in every state");
      
     
    // check consumption matrix for states with consumption - salaries < 0 (credit check)
      nerrors = 0;
      for (i=0;i<ninvestors;i++)
      {
         for(j=0;j<nstates;j++) 
            if ((consumptions[nstates*i+j]-salaries[nstates*i+j]) < 0) nerrors = nerrors+1;
      }   
      if (nerrors>0) aperrorhalt("Consumption from portfolio plus collateral for every investor must be positive or zero in every state");
           
  // make minconsumptions matrix with larger of minimum consumption and salary 
  //    if investor is type 4, minimum consumption is base plus MINCONSUMPTION
      minconsumptions = new double[ninvestors*nstates];
      minconsumptionssize = ninvestors*nstates;
      for (i=0;i<ninvestors;i++)
      {
         for(j=0;j<nstates;j++)  
         {
            invmin = MINCONSUMPTION;
            if (mutils[mutilscolumns*i+0] == 4) 
            {  
               invmin = mutils[mutilscolumns*i+1] + invmin;
            }   
            if (MINCONSUMPTION > invmin) invmin = MINCONSUMPTION;
            #ifdef MEMCHECK
               if ((nstates*i+j)>minconsumptionssize) aperrorhalt("Memory error: apmakestd 03");
            #endif      
            minconsumptions[nstates*i+j] = invmin;
            if (salaries[nstates*i+j] > MINCONSUMPTION) minconsumptions[nstates*i+j] = salaries[nstates*i+j];
         }
      } 
        
  // check consumption matrix for states with consumption < minconsumption (credit check)
      nerrors = 0;
      for (i=0;i<ninvestors;i++)
      {
         for(j=0;j<nstates;j++) 
            if ((consumptions[nstates*i+j]-minconsumptions[nstates*i+j]) < 0) nerrors = nerrors+1;
      }   
      if (nerrors>0) aperrorhalt("For every investor, consumption must be greater than or equal to minimum consumption in every state");
           
  // make portfolio values matrix
      portfoliovals = new double[ninvestors*nstates];
      portfoliovalssize = ninvestors*nstates;
    
  // make portfolio returns matrix
      portfolioreturns = new double[ninvestors*nstates];
      portfolioreturnssize = ninvestors*nstates;
      
  // make market vectors
      marketportfolio = new double[nsecurities];
        marketportfoliosize = nsecurities;
      marketconsumption = new double[nstates];
        marketconsumptionsize = nstates;
      marketsalaries    = new double[nstates];
        marketsalariessize = nstates;
      marketcollateral  = new double[nstates];
        marketcollateralsize = nstates;
      marketvals = new double[nsecurities];
        marketvalssize = nsecurities;
      marketreturns = new double[nstates-1];
        marketreturnssize = nstates-1;
         
  // make security price vector and set first to 1 and others to infinity
      securityprices = new double[nsecurities];
      securitypricessize = nsecurities;
      securityprices[0] = 1;
      for (sec=1;sec<nsecurities;sec++)
      {  
          #ifdef MEMCHECK
             if (sec>securitypricessize) aperrorhalt("Memory error: apmakestd 04");
          #endif      
          securityprices[sec] = INFINITY;
      }    

  // make matrix for reservation prices with security 1 as numeraire
      respsecurities = new double[ninvestors*nsecurities];
      respsecuritiessize = ninvestors*nsecurities;
            
  // make vectors for reservation price, buy price and sell price for each investor
      resp =  new double[ninvestors];
        respsize = ninvestors;
      buyp =  new double[ninvestors];
        buypsize = ninvestors;
      sellp = new double[ninvestors];
        sellpsize = ninvestors;
                  
  // make vector for amounts each investor will trade of tradesecurity at tradeprice
      tradev = new double[ninvestors];     
        tradevsize = ninvestors;
      
  // make conschg for amounts of consumption change by state for a trade 
      conschg = new double[nstates];
        conschgsize = nstates;
      
  // make vector for state prices and set first to 1 and others to infinity
      stateprices = new double[nstates];
        statepricessize = nstates;
      stateprices[0] = 1;
      for (state=1;state<nstates;state++) 
      {
         #ifdef MEMCHECK
            if (state>statepricessize) aperrorhalt("Memory error: apmakestd 05");
         #endif      
         stateprices[state] = INFINITY;      
      }   
      
  // make vector for market ppcs
      marketppcs = new double[nstates];
        marketppcssize = nstates;
      
  // make matrix for reservation prices for states
      respstates = new double[ninvestors*nstates];
        respstatessize = ninvestors*nstates;
      
  // make matrix for ppcs
     ppcs =  new double[ninvestors*nstates];
       ppcssize = ninvestors*nstates;
  
  // make matrix for security returns in future states
     securityreturns = new double[nsecurities*(nstates-1)];
       securityreturnssize = nsecurities*(nstates-1);
     
  // make matrix for portfolio returns in future states
     portfolioreturns = new double[ninvestors*(nstates-1)];
       portfolioreturnssize = ninvestors*(nstates-1);
     
  // make character vector for sorted names of states
     sortedstatenames = new char[strlen(statenames)];
      
  // make integer vector for locations of state names
     namepos = new int[nstates];
       namepossize = nstates;
     
  // make character vector with names of future states
     fstatenames = new char[strlen(statenames)];
     fstatenames = new char[strlen(statenames)];
     num=0; cnt=0;lgth = strlen(statenames);
     for (i=0;i<lgth;i++)
     {
        if (statenames[i]=='|') num=num+1;
        if (num>1) {fstatenames[cnt] = statenames[i]; cnt=cnt+1; }
        fstatenames[cnt] = '\0';
     }
     
  // make character vector with names of future securities
     fsecuritynames = new char[strlen(securitynames)];
     num=0; cnt=0;lgth = strlen(securitynames);
     for (i=0;i<lgth;i++)
     {
        if (securitynames[i]=='|') num=num+1;
        if (num>1) {fsecuritynames[cnt] = securitynames[i]; cnt=cnt+1; }
        fsecuritynames[cnt] = '\0';
     }
     
  // make matrix for future security characteristics  
      securitychars = new double[(nsecurities-1)*8];
        securitycharssize = (nsecurities-1)*8;
      
  // make character array for characteristic names
      charnames = new char[200];
      strncpy(charnames,"|Exp Return|Exp ER|SD Return|SR|Beta|Alpha|PwrBeta|PwrAlpha|",199);
      
  // make character array for names of sorted kernel and Consmption rows
      kernelnames = new char[200];
      strncpy(kernelnames,"|Total Consumption|PPC|",199);

  // make character array for names of sorted kernel and Consmption rows
      kernelnames2 = new char[200];
      strncpy(kernelnames2,"|Market Return|PPC|",199);

 // make matrix for portfolio characteristics  
      portfoliochars = new double[ninvestors*8];
        portfoliocharssize = ninvestors*8;

  // make vector for market characteristics
      marketchars = new double[8];
        marketcharssize = 8;
      
  // make vectors for one investor's consumptions and state reservation prices
     invcons = new double[nstates];
       invconssize = nstates;
     invrps   = new double[nstates];
       invrpssize = nstates;
     
  // make vectors for sorting
     statevals = new double[nstates];
       statevalssize = nstates;
     statepos  = new int[nstates];
       statepossize = nstates;
     
  // make matrix for sorted returns
     sortedreturns = new double[ninvestors*nstates];
       sortedreturnssize = ninvestors*nstates;
       
  // make matrix for sorted pricing kernel
     sortedkernel = new double(2*nstates);
        sortedkernelsize = 2*nstates;
     
  // make matrix and row and column names for power parameters
     powerparams = new double[3*1];
       powerparamssize = 3*1;
     powerrownames = new char[200];
      strncpy(powerrownames,"|Risk Aversion|Discount|R-squared|",199);
     powercolnames = new char[200];
      strncpy(powercolnames,"|Parameter|",199);

 } 
 
 
