/* apputbm
  writes a bordered matrix on file  
     *name:      string  name of matrix                   
     nrows:     int     number of rows in array
     ncols:     int     number of columns in array
    *rownames:  string  | separated list of row names    
    *colnames:  string  | separated list of column names 
    *mat:       double  matrix as new row-wise array     
    *fido:        FILE    file id for output
     places:      number of places in format

 output file pointed to by fid:
    information is written in bordered matrix format 

*/

void apputbm(char *name,int nrows, int ncols, char *rownames, char *colnames, double *mat, FILE *fido,int places)
/* puts bordered matrix on file
    *bmcolnames, *bmrownames, bmnrows, bmncols and *bmmat
   bmname is the name of the matrix 
   places is the number of places for formatting
*/
{
   char stg[110];
   int row,col,i,j,lgth;
   char tok[1000];
   double mval;
 
  // put matrix name
     fprintf(fido,"%s\n",name);
     
  // put format string
     if (places<1)
       {
         fprintf(fido,"0\n");
       }
     else
       { fprintf(fido,"0.");
         for (i=1;i<=places;i++) fprintf(fido,"0");
         fprintf(fido,"\n");
       }

     
  // put total number of rows and columns
     fprintf(fido,"%d\n",nrows+1);
     fprintf(fido,"%d\n",ncols+1);
  // put separator
     fprintf(fido,"----------\n");   
     
  // put column names
     lgth = strlen(colnames);
     tok[0]='\0';
     j=0;
     for (i=1;i<lgth;i++)
     {  
       if (colnames[i]=='|') 
         {
            tok[j]='\0';
            fprintf(fido,"%s\n",tok);
            j=0;
         }
        else
         {
            tok[j]=colnames[i];
            j++;
         }
      }
  // put separator
     fprintf(fido,"----------\n");   
     
  // put row names
     lgth = strlen(rownames);
     tok[0]='\0';
     j=0;
     for (i=1;i<lgth;i++)
     {  
       if (rownames[i]=='|') 
         {
            tok[j]='\0';
            fprintf(fido,"%s\n",tok);
            j=0;
         }
        else
         {
            tok[j]=rownames[i];
            j++;
         }
      }
  
  // put separator
     fprintf(fido,"----------\n");   
     
  // put matrix values
     for (row=0;row<nrows;row++)
     {
        for (col=0;col<ncols;col++)
        {
           mval = mat[row*ncols+col];
           fprintf(fido,"%g\n",mval);
        }
     }
     
  // put separator
     fprintf(fido,"==========\n");   
     
 } 

