/* aps2out.cpp
   writes output file apsimout.txt for case with state claims (complete market)
*/

void aps2out()
{
   FILE *fido;
   int inv,sec,state,i,j;
   double sum;
   
   // open output file for data
       fido=fopen("c:/apsim/apsimequilibrium.txt","w");
       
   // portfolios
       apput2bm("MARKET",marketportfolio,"Portfolios:",ninvestors,nsecurities,investornames,securitynames,portfolios,fido,2);
       
   // state claims
       apput2bm("MARKET",marketclaims,"Claims:",ninvestors,nstates,investornames,statenames,claims,fido,2);   
       
   // consumptions
       apput2bm("TOTAL",marketconsumption,"Consumptions:",ninvestors,nstates,investornames,statenames,consumptions,fido,1);
       
  // security prices
       apput2bm("MARKET",securityprices,"Security Prices:",ninvestors,nsecurities,investornames,securitynames,respsecurities,fido,2);
    
  // state prices
       apput2bm("MARKET",stateprices,"State Prices:",ninvestors,nstates,investornames,statenames,respstates,fido,2);
            
  // ppcs
       apput2bm("MARKET",marketppcs,"PPCs:",ninvestors,nstates,investornames,statenames,ppcs,fido,2);
       
 // portfolio values
       apput2bm("MARKET",marketvals,"Portfolio Values:",ninvestors,nsecurities,investornames,securitynames,portfoliovals,fido,2);         
  
  // portfolio returns
       apput2bm("MARKET",marketreturns,"Portfolio Returns:",ninvestors,nstates-1,investornames,fstatenames,portfolioreturns,fido,3);
                    
  // security returns
       apput2bm("MARKET",marketreturns,"Security Returns:",nsecurities-1,nstates-1,fsecuritynames,fstatenames,securityreturns,fido,3);
        
  // security characteristics
       apput2bm("MARKET",marketchars,"Security Characteristics:",nsecurities-1,8,fsecuritynames,charnames,securitychars,fido,3);
                                    
  // portfolio characteristics
       apput2bm("MARKET",marketchars,"Portfolio Characteristics:",ninvestors,8,investornames,charnames,portfoliochars,fido,3);
                           
  // power SML informtion
       apputbm("Kernel Approximation:",3,1,powerrownames,powercolnames,powerparams,fido,2);
    
  // pricing kernel sorted by total consumption
      // put market consumption in statevals
         for (state=0;state<nstates;state++) 
         {
            #ifdef MEMCHECK
                if (state>statevalssize) aperrorhalt("Memory error: aps2out 01");
            #endif   
            statevals[state] = marketconsumption[state];
         }    
      // find positions of states when sorted in ascending order of statevals
         apsortsv();
         
      // put data in sortedkernel
         for (j=0;j<nstates;j++)
           {
            #ifdef MEMCHECK
                if ((1*nstates+j)>sortedkernelsize) aperrorhalt("Memory error: aps2out 02");
            #endif   
            sortedkernel[0*nstates+j] =  marketconsumption[statepos[j]];  
            sortedkernel[1*nstates+j] =  marketppcs[statepos[j]];
           }
         apputbm("PPCs & Consumptions:",2,nstates,kernelnames,sortedstatenames,sortedkernel,fido,2);
                  
   // pricing kernel sorted by market returns
      // put market returns in statevals
         statevals[0] = 1;
         for (state=0;state<nstates-1;state++)
         {
            #ifdef MEMCHECK
                if ((state+1)>statevalssize) aperrorhalt("Memory error: ap2out 01");
            #endif   
            statevals[state+1] = marketreturns[state];
         }   
    // find positions of states when sorted in ascending order of statevals
         apsortsv();
      // put data in sortedkernel
         for (j=0;j<nstates;j++)
           {
            #ifdef MEMCHECK
                if ((1*nstates+j)>sortedkernelsize) aperrorhalt("Memory error: ap2out 02");
            #endif   
            sortedkernel[0*nstates+j] =  statevals[statepos[j]];  
            sortedkernel[1*nstates+j] =  marketppcs[statepos[j]];
           }
         apputbm("PPCs & Market Returns:",2,nstates,kernelnames2,sortedstatenames,sortedkernel,fido,2);
   
   // portfolio returns sorted by market returns
      // put market returns in statevals
         for (j=0;j<(nstates-1);j++) 
         {
             #ifdef MEMCHECK
                if (j>statevalssize) aperrorhalt("Memory error: aps2out 04");
             #endif   
             statevals[j] = marketreturns[j];
         }   
      // find positions of states when sorted in ascending order of statevals
         apsortsvret();
      // put sorted market returns in statevals
         for (j=0;j<nstates-1;j++) 
         {
            #ifdef MEMCHECK
                if (j>statevalssize) aperrorhalt("Memory error: aps2out 05");
            #endif   
            statevals[j] = marketreturns[statepos[j]];
         }   
      // put portfolio returns in sortedreturns and write table
         for (i=0;i<ninvestors;i++)
            for (j=0;j<nstates-1;j++)
            {
               #ifdef MEMCHECK
                  if (((nstates-1)*i+j)>sortedreturnssize) aperrorhalt("Memory error: aps2out 06");
               #endif   
               sortedreturns[(nstates-1)*i+j] =  portfolioreturns[(nstates-1)*i+statepos[j]];
            }   
          apput2bm("MARKET",statevals,"Sorted Portfolio Returns:",ninvestors,nstates-1,investornames,sortedstatenames,sortedreturns,fido,2);                    
 
  // close output file 
       fclose (fido);
       
 } 
 
 
