/* apsgetvals.cpp
   gets values and market information for complete market case
*/

void apsgetvals()
{
  double mval,mvals,mvalc,mvalclm,fval,portcons,mcons;
  int inv,sec,state;
  
 // market portfolio holdings as sum of investor portfolios
    for (sec=0;sec<nsecurities;sec++)
    {
      mval =0;
      for (inv=0;inv<ninvestors;inv++)
        {
           mval = mval + portfolios[nsecurities*inv+sec];
        }   
      #ifdef MEMCHECK
         if (sec>marketportfoliosize) aperrorhalt("Memory error: apsgetvals 01");
      #endif   
      marketportfolio[sec] = mval;  
    };   
    
// market consumptions, salaries, collateral and claims as sum of investor values
    for (state=0;state<nstates;state++)
    {
      mval =0;
      mvals = 0;
      mvalc = 0;
      mvalclm = 0;
      for (inv=0;inv<ninvestors;inv++)
        {
           mval = mval + consumptions[nstates*inv+state];
           mvals = mvals + salaries[nstates*inv+state];
           mvalc = mvalc + collateral[nstates*inv+state];
           mvalclm = mvalclm + claims[nstates*inv+state];
        }   
        
      #ifdef MEMCHECK
         if (state>marketconsumptionsize) aperrorhalt("Memory error: apsgetvals 02");
      #endif   
      marketconsumption[state] = mval;  
      #ifdef MEMCHECK
         if (state>marketsalariessize) aperrorhalt("Memory error: apsgetvals 03");
      #endif   
      marketsalaries[state]    = mvals;  
      #ifdef MEMCHECK
         if (state>marketcollateralsize) aperrorhalt("Memory error: apsgetvals 04");
      #endif   
      marketcollateral[state]  = mvalc;  
      #ifdef MEMCHECK
         if (state>marketclaimssize) aperrorhalt("Memory error: apsgetvals 05");
      #endif   
      marketclaims[state]      = mvalclm;
    };   

  // portfolio and market values as holdings times security prices
    for (sec=0;sec<nsecurities;sec++)
    {
      mval =0;
      for (inv=0;inv<ninvestors;inv++)
        {
           #ifdef MEMCHECK
              if ((nsecurities*inv+sec)>portfoliovalssize) aperrorhalt("Memory error: apsgetvals 06");
           #endif   
           portfoliovals[nsecurities*inv+sec] = securityprices[sec]*portfolios[nsecurities*inv+sec];
           mval = mval + portfoliovals[nsecurities*inv+sec];
        }   
      #ifdef MEMCHECK
          if (sec>marketvalssize) aperrorhalt("Memory error: apsgetvals 07");
      #endif   
      marketvals[sec] = mval;  
    };   
  
  // portfolio returns as (consumptions - collateral - salary) in future states divided by value of future securities
      for (inv=0;inv<ninvestors;inv++)
        {
           // get value of portfolio of future securities
              fval = 0;
              for (sec=1;sec<nsecurities;sec++) fval=fval+portfoliovals[nsecurities*inv+sec];
           // compute returns for future states   
              for(state=1;state<nstates;state++)
                { 
                   portcons = consumptions[nstates*inv+state]-salaries[nstates*inv+state]-collateral[nstates*inv+state];
                   #ifdef MEMCHECK
                       if (((nstates-1)*inv+(state-1))>portfolioreturnssize) aperrorhalt("Memory error: apsgetvals 08");
                   #endif   
                   portfolioreturns[(nstates-1)*inv+(state-1)] = portcons/fval; 
                }
        }   
        

   // market returns as market consumptions - salaries - collateral divided by value of market future securities for future states     
       // get value of market portfolio of future securities
            fval = 0;
            for (sec=1;sec<nsecurities;sec++) fval=fval+marketvals[sec];
       // compute returns for future states     
            for(state=1;state<nstates;state++)
               {  mcons = marketconsumption[state] - marketsalaries[state] - marketcollateral[state];
                  #ifdef MEMCHECK
                       if ((state-1)>marketreturnssize) aperrorhalt("Memory error: apsgetvals 09");
                  #endif   
                  marketreturns[state-1] = mcons/fval; 
               }
   
   // security returns as payoffs in future states divided by security prices
      for (sec=1;sec<nsecurities;sec++)
        {
              for(state=1;state<nstates;state++)
                {
                  #ifdef MEMCHECK
                       if (((nstates-1)*(sec-1)+(state-1))>securityreturnssize) aperrorhalt("Memory error: apsgetvals 10");
                  #endif   
                  securityreturns[(nstates-1)*(sec-1)+(state-1)] = securities[nsecurities*state+sec]/securityprices[sec];
                }
        }     
     
    // ppcs as state reservation prices divided by state probabilities
       for (inv=0;inv<ninvestors;inv++)
         {
           for (state=0;state<nstates;state++)
             {
                #ifdef MEMCHECK
                    if ((nstates*inv+state)>ppcssize) aperrorhalt("Memory error: apsgetvals 11");
                #endif   
                ppcs[nstates*inv+state] = respstates[nstates*inv+state]/probabilities[state];
             }   
         }

  // market ppcs as state prices divided by probabilities
       for (state=0;state<nstates;state++)
         {
           #ifdef MEMCHECK
               if (state>marketppcssize) aperrorhalt("Memory error: apsgetvals 12");
           #endif   
           marketppcs[state] = stateprices[state]/probabilities[state];
         }    
         
} 
 
 
